diff --git a/src/main/java/net/minecraft/core/block/BlockSugarcane.java b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
similarity index 82%
rename from src/main/java/net/minecraft/core/block/BlockSugarcane.java
rename to src/main/java/net/minecraft/core/block/SugarcaneBlock.java
index a9f0517e6..bcadba290 100644
--- a/src/main/java/net/minecraft/core/block/BlockSugarcane.java
+++ b/src/main/java/net/minecraft/core/block/SugarcaneBlock.java
@@ -1,13 +1,13 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
@@ -16,15 +16,15 @@ import net.minecraft.core.world.WorldSource;
 import java.util.Random;
 
 // Referenced classes of package net.minecraft.src:
-//            Block, Material, World, BlockGrass, 
+//            Block, Material, World, GrassBlock,
 //            Item, AxisAlignedBB
 
-public class BlockSugarcane extends Block implements IBonemealable
+public class SugarcaneBlock extends Block implements IBonemealable
 {
 
-	public BlockSugarcane(String key, int id)
+	public SugarcaneBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.plant);
+        super(key, namespaceId, id, Material.plant);
         float f = 0.375F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 1.0F, 0.5F + f);
         setTicking(true);
@@ -107,9 +107,9 @@ public class BlockSugarcane extends Block implements IBonemealable
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
-        return new ItemStack[] { new ItemStack(Item.sugarcane) };
+        return new ItemStack[] { new ItemStack(Items.SUGARCANE) };
     }
 
     @Override
@@ -131,16 +131,16 @@ public class BlockSugarcane extends Block implements IBonemealable
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
 
     @Override
-    public boolean onBonemealUsed(ItemStack itemstack, EntityPlayer entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
+    public boolean onBonemealUsed(ItemStack itemstack, Player entityplayer, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         if(!world.isClientSide)
         {
-            ((BlockSugarcane)Block.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
+            ((SugarcaneBlock)Block.blocksList[id]).growReedOnTop(world, blockX, blockY, blockZ);
             if (entityplayer.getGamemode().consumeBlocks())
             {
                 itemstack.stackSize--;
diff --git a/src/main/java/net/minecraft/core/block/BlockTNT.java b/src/main/java/net/minecraft/core/block/TNTBlock.java
similarity index 60%
rename from src/main/java/net/minecraft/core/block/BlockTNT.java
rename to src/main/java/net/minecraft/core/block/TNTBlock.java
index 7001b63cc..28509f42d 100644
--- a/src/main/java/net/minecraft/core/block/BlockTNT.java
+++ b/src/main/java/net/minecraft/core/block/TNTBlock.java
@@ -1,25 +1,24 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.entity.TNTPrimedEntity;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.ItemFirestriker;
+import net.minecraft.core.item.FireStrikerItem;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
-public class BlockTNT extends Block {
+public class TNTBlock extends Block {
 
-	public BlockTNT(String key, int id) {
-		super(key, id, Material.explosive);
+	public TNTBlock(String key, String namespaceId, int id) {
+		super(key, namespaceId, id, Material.explosive);
 	}
 
 	@Override
-	public void onBlockAdded(World world, int x, int y, int z) {
-		super.onBlockAdded(world, x, y, z);
+	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+		super.onBlockPlacedByWorld(world, x, y, z);
 		if (world.isBlockIndirectlyGettingPowered(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
@@ -27,13 +26,13 @@ public class BlockTNT extends Block {
 
 	@Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
-		if (blockId > 0 && Block.blocksList[blockId].canProvidePower() && world.isBlockIndirectlyGettingPowered(x, y, z)) {
+		if (blockId > 0 && Block.blocksList[blockId].isSignalSource() && world.isBlockIndirectlyGettingPowered(x, y, z)) {
 			ignite(world, x, y, z, true);
 		}
 	}
 
 	@Override
-	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+	public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
 	{
 		if (dropCause == EnumDropCause.EXPLOSION)
 		{
@@ -44,7 +43,7 @@ public class BlockTNT extends Block {
 
 	@Override
 	public void onBlockDestroyedByExplosion(World world, int x, int y, int z) {
-		EntityTNT entity = new EntityTNT(world, x + 0.5F, y + 0.5F, z + 0.5F);
+		TNTPrimedEntity entity = new TNTPrimedEntity(world, x + 0.5F, y + 0.5F, z + 0.5F);
 		entity.fuse = world.rand.nextInt(entity.fuse / 4) + entity.fuse / 8;
 		world.entityJoinedWorld(entity);
 	}
@@ -53,33 +52,33 @@ public class BlockTNT extends Block {
 		ignite(world, x, y, z, null, sound);
 	}
 
-	public void ignite(World world, int x, int y, int z, EntityPlayer player, boolean sound) {
+	public void ignite(World world, int x, int y, int z, Player player, boolean sound) {
 		if (world.isClientSide) {
-			if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof ItemFirestriker)) {
+			if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof FireStrikerItem)) {
 				player.inventory.getCurrentItem().damageItem(1, player);
 			}
 			return;
 		}
 		world.setBlockWithNotify(x, y, z, 0);
-		EntityTNT e = new EntityTNT(world, x + 0.5F, y + 0.5F, z + 0.5F);
+		TNTPrimedEntity e = new TNTPrimedEntity(world, x + 0.5F, y + 0.5F, z + 0.5F);
 		world.entityJoinedWorld(e);
 		world.playSoundAtEntity(null, e, "random.fuse", 1.0F, 1.0F);
-		if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof ItemFirestriker)) {
+		if (player != null && player.inventory.getCurrentItem() != null && (player.inventory.getCurrentItem().getItem() instanceof FireStrikerItem)) {
 			player.inventory.getCurrentItem().damageItem(1, player);
 		}
 	}
 
 	@Override
-	public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
-		if (player.getCurrentEquippedItem() != null && player.getCurrentEquippedItem().getItem() instanceof ItemFirestriker) {
+	public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
+		if (player.getCurrentEquippedItem() != null && player.getCurrentEquippedItem().getItem() instanceof FireStrikerItem) {
 			world.setBlockMetadata(x, y, z, 1);
 		}
 		super.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
 	}
 
 	@Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced) {
-		if (player.inventory.getCurrentItem() != null && player.inventory.getCurrentItem().getItem() instanceof ItemFirestriker) {
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced) {
+		if (player.inventory.getCurrentItem() != null && player.inventory.getCurrentItem().getItem() instanceof FireStrikerItem) {
 			ignite(world, x, y, z, player, true);
 			return true;
 		}
diff --git a/src/main/java/net/minecraft/core/block/BlockTallGrass.java b/src/main/java/net/minecraft/core/block/TallGrassBlock.java
similarity index 63%
rename from src/main/java/net/minecraft/core/block/BlockTallGrass.java
rename to src/main/java/net/minecraft/core/block/TallGrassBlock.java
index 39fcc8a28..6b7d8c44f 100644
--- a/src/main/java/net/minecraft/core/block/BlockTallGrass.java
+++ b/src/main/java/net/minecraft/core/block/TallGrassBlock.java
@@ -1,34 +1,37 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.material.MaterialColor;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.world.World;
 
 // Referenced classes of package net.minecraft.src:
-//            BlockFlower, IBlockAccess, WorldChunkManager, ColorizerGrass, 
+//            FlowerBlock, IBlockAccess, WorldChunkManager, ColorizerGrass,
 //            Item
 
-public class BlockTallGrass extends BlockFlower
+public class TallGrassBlock extends FlowerBlock
 {
-	public BlockTallGrass(String key, int id)
+	public TallGrassBlock(String key, String namespaceId, int id)
     {
-        super(key, id);
+        super(key, namespaceId, id);
         float f = 0.4F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, 0.8F, 0.5F + f);
+        withOverrideColor(MaterialColor.grass);
     }
 
     @Override
     protected boolean canThisPlantGrowOnThisBlockID(int i) {
     	Block block = Block.getBlock(i);
-    	if(block != null && block instanceof BlockMoss) {
+    	if(block != null && block instanceof MossBlock) {
     		return true;
     	}
     	return super.canThisPlantGrowOnThisBlockID(i);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockFenceThin.java b/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
similarity index 78%
rename from src/main/java/net/minecraft/core/block/BlockFenceThin.java
rename to src/main/java/net/minecraft/core/block/ThinFenceBlock.java
index ae287f6b4..7eb18be65 100644
--- a/src/main/java/net/minecraft/core/block/BlockFenceThin.java
+++ b/src/main/java/net/minecraft/core/block/ThinFenceBlock.java
@@ -4,11 +4,11 @@ import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
 
-public abstract class BlockFenceThin extends Block
+public abstract class ThinFenceBlock extends Block
 {
-    public BlockFenceThin(String key, int id, Material material)
+    public ThinFenceBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
@@ -24,7 +24,7 @@ public abstract class BlockFenceThin extends Block
         boolean connectXNeg = canConnectTo(world, x - 1, y, z);
         boolean connectZPos = canConnectTo(world, x, y, z + 1);
         boolean connectZNeg = canConnectTo(world, x, y, z - 1);
-        return AABB.getBoundingBoxFromPool(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1, z + 1 - (connectZPos ? 0.0f : 0.375f));
+        return AABB.getTemporaryBB(x + (connectXNeg ? 0.0f : 0.375f), y, z + (connectZNeg ? 0.0f : 0.375f), x + 1 - (connectXPos ? 0.0f : 0.375f), (float) y + 1, z + 1 - (connectZPos ? 0.0f : 0.375f));
     }
 
     @Override
@@ -52,7 +52,7 @@ public abstract class BlockFenceThin extends Block
     }
 
     @Override
-    public boolean renderAsNormalBlock()
+    public boolean isCubeShaped()
     {
         return false;
     }
diff --git a/src/main/java/net/minecraft/core/block/ThornLeavesBlock.java b/src/main/java/net/minecraft/core/block/ThornLeavesBlock.java
new file mode 100644
index 000000000..4ca86074d
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/ThornLeavesBlock.java
@@ -0,0 +1,17 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+
+public class ThornLeavesBlock extends BaseLeavesBlock
+{
+    public ThornLeavesBlock(String key, String namespaceId, int id)
+    {
+        super(key, namespaceId, id, Material.leaves);
+    }
+    @Override
+    protected Block getSapling()
+    {
+        return Blocks.SAPLING_THORN;
+    }
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockGlassTinted.java b/src/main/java/net/minecraft/core/block/TintedGlassBlock.java
similarity index 70%
rename from src/main/java/net/minecraft/core/block/BlockGlassTinted.java
rename to src/main/java/net/minecraft/core/block/TintedGlassBlock.java
index ca92ffc2d..1fa8b99e3 100644
--- a/src/main/java/net/minecraft/core/block/BlockGlassTinted.java
+++ b/src/main/java/net/minecraft/core/block/TintedGlassBlock.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.block.material.Material;
@@ -9,12 +9,12 @@ import net.minecraft.core.world.World;
 // Referenced classes of package net.minecraft.src:
 //            BlockBreakable, Material
 
-public class BlockGlassTinted extends BlockGlass
+public class TintedGlassBlock extends GlassBlock
 {
 
-    public BlockGlassTinted(String key, int id)
+    public TintedGlassBlock(String key, String namespaceID, int id)
     {
-        super(key, id, Material.glass);
+        super(key, namespaceID, id, Material.glass);
     }
 
 
@@ -25,13 +25,13 @@ public class BlockGlassTinted extends BlockGlass
     }
 
     @Override
-    public int getRenderBlockPass()
+    public int getRenderLayer()
     {
         return 1;
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
diff --git a/src/main/java/net/minecraft/core/block/BlockTorch.java b/src/main/java/net/minecraft/core/block/TorchBlock.java
similarity index 90%
rename from src/main/java/net/minecraft/core/block/BlockTorch.java
rename to src/main/java/net/minecraft/core/block/TorchBlock.java
index 248a1700a..9a6a29bcf 100644
--- a/src/main/java/net/minecraft/core/block/BlockTorch.java
+++ b/src/main/java/net/minecraft/core/block/TorchBlock.java
@@ -1,12 +1,12 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.HitResult;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
@@ -16,12 +16,12 @@ import java.util.Random;
 //            Block, Material, World, AxisAlignedBB, 
 //            Vec3D, MovingObjectPosition
 
-public class BlockTorch extends Block
+public class TorchBlock extends Block
 {
 
-	public BlockTorch(String key, int id)
+	public TorchBlock(String key, String namespaceId, int id)
     {
-        super(key, id, Material.decoration);
+        super(key, namespaceId, id, Material.decoration);
         setTicking(true);
     }
 
@@ -38,7 +38,7 @@ public class BlockTorch extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -46,7 +46,7 @@ public class BlockTorch extends Block
     private boolean canPlaceOnTop(World world, int x, int y, int z)
     {
     	int id = world.getBlockId(x, y, z);
-        return world.canPlaceOnSurfaceOfBlock(x, y, z) || id == Block.fencePlanksOak.id || id == Block.fencePlanksOakPainted.id;
+        return world.canPlaceOnSurfaceOfBlock(x, y, z) || id == Blocks.FENCE_PLANKS_OAK.id || id == Blocks.FENCE_PLANKS_OAK_PAINTED.id;
     }
 
     @Override
@@ -72,7 +72,7 @@ public class BlockTorch extends Block
     }
 
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
     	int l = side.getId();
         int i1 = world.getBlockMetadata(x, y, z);
         if(l == 1 && canPlaceOnTop(world, x, y - 1, z))
@@ -104,12 +104,12 @@ public class BlockTorch extends Block
         super.updateTick(world, x, y, z, rand);
         if(world.getBlockMetadata(x, y, z) == 0)
         {
-            onBlockAdded(world, x, y, z);
+            onBlockPlacedByWorld(world, x, y, z);
         }
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
         if(world.isBlockNormalCube(x - 1, y, z))
         {
@@ -183,7 +183,7 @@ public class BlockTorch extends Block
     }
 
     @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3d start, Vec3d end)
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
     {
         int l = world.getBlockMetadata(x, y, z) & 7;
         float f = 0.15F;
@@ -211,7 +211,7 @@ public class BlockTorch extends Block
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         int l = world.getBlockMetadata(x, y, z);
         double xPos = (double) x + 0.5D;
diff --git a/src/main/java/net/minecraft/core/block/BlockTransparent.java b/src/main/java/net/minecraft/core/block/TransparentBlock.java
similarity index 50%
rename from src/main/java/net/minecraft/core/block/BlockTransparent.java
rename to src/main/java/net/minecraft/core/block/TransparentBlock.java
index 92db3ee62..85ee513ca 100644
--- a/src/main/java/net/minecraft/core/block/BlockTransparent.java
+++ b/src/main/java/net/minecraft/core/block/TransparentBlock.java
@@ -2,12 +2,12 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
 
-public abstract class BlockTransparent extends Block
+public abstract class TransparentBlock extends Block
 {
 
-	public BlockTransparent(String key, int id, Material material)
+	public TransparentBlock(String key, String namespaceId, int id, Material material)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
similarity index 81%
rename from src/main/java/net/minecraft/core/block/BlockTrapDoor.java
rename to src/main/java/net/minecraft/core/block/TrapDoorBlock.java
index a14558983..72e5b8adf 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrapDoor.java
+++ b/src/main/java/net/minecraft/core/block/TrapDoorBlock.java
@@ -1,32 +1,32 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.HitResult;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityLiving;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.enums.PlacementMode;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.item.tag.ItemTags;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, IBlockAccess, World, 
-//            AxisAlignedBB, EntityPlayer, Vec3D, MovingObjectPosition
+//            AxisAlignedBB, Player, Vec3D, MovingObjectPosition
 
-public class BlockTrapDoor extends Block
+public class TrapDoorBlock extends Block
 {
 
 	
 	private boolean isIron;
 	
-	public BlockTrapDoor(String key, int id, Material material, boolean isIron)
+	public TrapDoorBlock(String key, String namespaceId, int id, Material material, boolean isIron)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         float f = 0.5F;
         float f1 = 1.0F;
         setBlockBounds(0.5F - f, 0.0F, 0.5F - f, 0.5F + f, f1, 0.5F + f);
@@ -40,7 +40,7 @@ public class BlockTrapDoor extends Block
     }
 
     @Override
-	public boolean renderAsNormalBlock()
+	public boolean isCubeShaped()
     {
         return false;
     }
@@ -97,14 +97,14 @@ public class BlockTrapDoor extends Block
     }
     
     @Override
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit) {
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit) {
     	if(!Item.hasTag(player.getCurrentEquippedItem(), ItemTags.PREVENT_LEFT_CLICK_INTERACTIONS)) {
     		onBlockRightClicked(world, x, y, z, player, null, 0.0, 0.0);
     	}
     }
 
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (blockMaterial != Material.metal) {
             int l = world.getBlockMetadata(x, y, z);
@@ -121,7 +121,7 @@ public class BlockTrapDoor extends Block
 			return;
 		}
 
-		if(isIron || blockId > 0 && Block.getBlock(blockId).canProvidePower()) {
+		if(isIron || blockId > 0 && Block.getBlock(blockId).isSignalSource()) {
 			int meta = world.getBlockMetadata(x, y, z);
 			boolean isOpened = isTrapdoorOpen(meta);
 			boolean isPowered = world.isBlockIndirectlyGettingPowered(x, y, z);
@@ -134,16 +134,16 @@ public class BlockTrapDoor extends Block
 	}
 
     @Override
-    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3d start, Vec3d end)
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end)
     {
         setBlockBoundsBasedOnState(world, x, y, z);
         return super.collisionRayTrace(world, x, y, z, start, end);
     }
     
     @Override
-    public void onBlockPlaced(World world, int x, int y, int z, Side side, EntityLiving entity, double sideHeight) {
-    	int meta = getMetaForDirection(entity.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
-    	if(entity.getVerticalPlacementDirection(side, sideHeight) == Direction.UP) {
+    public void onBlockPlacedByMob(World world, int x, int y, int z, Side side, Mob mob, double sideHeight) {
+    	int meta = getMetaForDirection(mob.getHorizontalPlacementDirection(side, PlacementMode.SIDE));
+    	if(mob.getVerticalPlacementDirection(side, sideHeight) == Direction.UP) {
     		meta |= 8;
     	}
     	world.setBlockMetadata(x, y, z, meta);
@@ -153,8 +153,8 @@ public class BlockTrapDoor extends Block
     public boolean isClimbable(World world, int x, int y, int z) {
     	Block block = world.getBlock(x, y - 1, z);
     	int meta = world.getBlockMetadata(x, y, z);
-    	if(isTrapdoorOpen(meta) && block instanceof BlockLadder) {
-    		BlockLadder ladder = (BlockLadder) block;
+    	if(isTrapdoorOpen(meta) && block instanceof LadderBlock) {
+    		LadderBlock ladder = (LadderBlock) block;
     		Side ladderSide = ladder.getSideFromMeta(world.getBlockMetadata(x, y - 1, z));
     		Direction trapdoorDirection = getDirectionForMeta(meta);
     		return ladderSide.getDirection().getOpposite() == trapdoorDirection;
diff --git a/src/main/java/net/minecraft/core/block/BlockTrommel.java b/src/main/java/net/minecraft/core/block/TrommelBlock.java
similarity index 68%
rename from src/main/java/net/minecraft/core/block/BlockTrommel.java
rename to src/main/java/net/minecraft/core/block/TrommelBlock.java
index feb818e32..12887ff9c 100644
--- a/src/main/java/net/minecraft/core/block/BlockTrommel.java
+++ b/src/main/java/net/minecraft/core/block/TrommelBlock.java
@@ -1,11 +1,11 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.Global;
-import net.minecraft.core.block.entity.TileEntity;
-import net.minecraft.core.block.entity.TileEntityTrommel;
+import net.minecraft.core.block.entity.BlockEntity;
+import net.minecraft.core.block.entity.TrommelBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
@@ -13,24 +13,24 @@ import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-public class BlockTrommel extends BlockTileEntityRotatable
+public class TrommelBlock extends RotatableEntityBlock
 {
-	public BlockTrommel(String key, int id, Material material, boolean isActive)
+	public TrommelBlock(String key, String namespaceId, int id, Material material, boolean isActive)
     {
-        super(key, id, material);
+        super(key, namespaceId, id, material);
         this.isActive = isActive;
         random = new Random();
     }
 
     @Override
-	public void onBlockAdded(World world, int x, int y, int z)
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
     {
-        super.onBlockAdded(world, x, y, z);
+        super.onBlockPlacedByWorld(world, x, y, z);
         setDefaultDirection(world, x, y, z);
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
@@ -38,24 +38,24 @@ public class BlockTrommel extends BlockTileEntityRotatable
             case EXPLOSION:
             case PROPER_TOOL:
             case SILK_TOUCH:
-                return new ItemStack[] { new ItemStack(Block.trommelIdle) };
+                return new ItemStack[] { new ItemStack(Blocks.TROMMEL_IDLE) };
             default:
                 return null;
         }
     }
     
     @Override
-    public boolean onBlockRightClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xPlaced, double yPlaced)
+    public boolean onBlockRightClicked(World world, int x, int y, int z, Player player, Side side, double xPlaced, double yPlaced)
     {
         if (!world.isClientSide) {
-            TileEntityTrommel tileEntityTrommel = (TileEntityTrommel) world.getBlockTileEntity(x, y, z);
+            TrommelBlockEntity tileEntityTrommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
             player.displayGUITrommel(tileEntityTrommel);
         }
         return true;
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(!isActive)
             return;
@@ -68,7 +68,7 @@ public class BlockTrommel extends BlockTileEntityRotatable
     public static void updateTrommelBlockState(boolean flag, World world, int i, int j, int k)
     {
         int l = world.getBlockMetadata(i, j, k);
-        TileEntity tileentity = world.getBlockTileEntity(i, j, k);
+        BlockEntity tileentity = world.getBlockEntity(i, j, k);
         if(tileentity == null) {
             String msg = "Trommel is missing Tile Entity at x: " + i + " y: " + j + " z: " + k + ", block will be removed!";
             if(Global.BUILD_CHANNEL.isUnstableBuild()) {
@@ -81,10 +81,10 @@ public class BlockTrommel extends BlockTileEntityRotatable
         keepTrommelInventory = true;
         if(flag)
         {
-            world.setBlockWithNotify(i, j, k, Block.trommelActive.id);
+            world.setBlockWithNotify(i, j, k, Blocks.TROMMEL_ACTIVE.id);
         } else
         {
-            world.setBlockWithNotify(i, j, k, Block.trommelIdle.id);
+            world.setBlockWithNotify(i, j, k, Blocks.TROMMEL_IDLE.id);
         }
         keepTrommelInventory = false;
         world.setBlockMetadataWithNotify(i, j, k, l);
@@ -97,13 +97,13 @@ public class BlockTrommel extends BlockTileEntityRotatable
     {
     	if (!keepTrommelInventory)
     	{
-    		if(world.getBlockTileEntity(x, y, z) != null)
+    		if(world.getBlockEntity(x, y, z) != null)
     		{
-    			TileEntityTrommel tileentitytrommel = (TileEntityTrommel) world.getBlockTileEntity(x, y, z);
+    			TrommelBlockEntity tileentitytrommel = (TrommelBlockEntity) world.getBlockEntity(x, y, z);
     			label0:
-				for (int l = 0; l < tileentitytrommel.getSizeInventory(); l++) 
+				for (int l = 0; l < tileentitytrommel.getContainerSize(); l++)
 				{
-					ItemStack itemstack = tileentitytrommel.getStackInSlot(l);
+					ItemStack itemstack = tileentitytrommel.getItem(l);
 					if (itemstack == null) {
 						continue;
 					}
@@ -119,7 +119,7 @@ public class BlockTrommel extends BlockTileEntityRotatable
 							i1 = itemstack.stackSize;
 						}
 						itemstack.stackSize -= i1;
-						EntityItem entityitem = new EntityItem(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
+						ItemEntity entityitem = new ItemEntity(world, (float) x + f, (float) y + f1, (float) z + f2, new ItemStack(itemstack.itemID, i1, itemstack.getMetadata()));
 						float f3 = 0.05F;
 						entityitem.xd = (float) random.nextGaussian() * f3;
 						entityitem.yd = (float) random.nextGaussian() * f3 + 0.2F;
@@ -135,9 +135,9 @@ public class BlockTrommel extends BlockTileEntityRotatable
 
 
     @Override
-	protected TileEntity getNewBlockEntity()
+	protected BlockEntity getNewBlockEntity()
     {
-        return new TileEntityTrommel();
+        return new TrommelBlockEntity();
     }
 
     private boolean isActive;
